AllocCurTDAT		PROTO	STDCALL
DestroyCurTDAT		PROTO	STDCALL
LoadTDATFromFile 	PROTO 	STDCALL
ClearCurTDAT		PROTO	STDCALL
LoadBrainFromFile	PROTO 	STDCALL :DWORD
SaveBrainToFile		PROTO 	STDCALL :DWORD

.code


AllocCurTDAT	proc
	invoke	GetProcessHeap
	invoke	HeapAlloc, eax, HEAP_ZERO_MEMORY, SIZEOF TDAT*26
	mov		pCurTDAT, eax
ret
AllocCurTDAT	endp

DestroyCurTDAT	proc
	invoke	GetProcessHeap
	invoke	HeapFree, eax, 0, pCurTDAT
ret
DestroyCurTDAT	endp

ClearCurTDAT proc
	invoke memfill, pCurTDAT, SIZEOF TDAT*26, 0
ret
ClearCurTDAT endp

LoadTDATFromFile	proc uses esi edi ebx
LOCAL	BytesRead:DWORD
	mov		ebx, hCurTDATFile
	.IF		!ebx
		xor		eax, eax
		ret
	.ENDIF

	invoke 	GetFileSize, ebx, NULL
	.IF		eax!=(SIZEOF TDAT*26)
		invoke	MessageBox, NULL, addr errInvalidTDATFile, addr AppName, MB_ICONERROR
		xor		eax, eax
		ret
	.ENDIF
	
	lea		ecx, BytesRead
	invoke	ReadFile, ebx, pCurTDAT, eax, ecx, NULL
	
	xor		eax, eax
	inc		eax
ret
LoadTDATFromFile	endp


LoadBrainFromFile	proc uses ebx hWndParent:DWORD
LOCAL	ofn:OPENFILENAME
LOCAL	buffer[MAX_PATH]:BYTE

	xor	ecx, ecx
	lea	edx, ofn
	.WHILE	ecx<(SIZEOF OPENFILENAME/4)
		mov dword ptr [edx][ecx*4], 0
		inc ecx
	.ENDW
	
	mov	byte ptr [buffer],0
	
  	mov ofn.lStructSize, SIZEOF OPENFILENAME
    mov	eax, hWndParent
    mov	ecx, hInstance
    mov	ofn.hWndOwner, eax
    mov ofn.hInstance, ecx
	mov ofn.lpstrFilter, offset filterBrain
    lea	ecx, buffer
    mov ofn.nMaxFile, MAX_PATH
    mov ofn.lpstrFile, ecx
    mov ofn.lpstrTitle, offset brainTitleLoad
    mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST
    invoke GetOpenFileName, addr ofn
    .IF		eax
    	invoke	CreateFile, addr buffer, GENERIC_READ,\
    				FILE_SHARE_READ, NULL, OPEN_EXISTING,\
    				NULL, NULL
    	mov ebx, eax
    	.IF		eax==INVALID_HANDLE_VALUE
    		invoke	MessageBox, hWndParent, addr errOpenFile, addr AppName, MB_ICONERROR
    	.ELSE
    		method lpCharNet, NNet, load, NNETFLAG_FROMFILE, ebx
    		.IF	   !eax
	    		invoke	MessageBox, hWndParent, addr errInvalidBrain, addr AppName, MB_ICONERROR
	    	.ENDIF
	    	invoke	CloseHandle, ebx
	    .ENDIF
    .ENDIF
ret
LoadBrainFromFile	endp

SaveBrainToFile		proc hWndParent:DWORD
LOCAL	ofn:OPENFILENAME
LOCAL	buffer[MAX_PATH]:BYTE

	xor	ecx, ecx
	lea	edx, ofn
	.WHILE	ecx<(SIZEOF OPENFILENAME/4)
		mov dword ptr [edx][ecx*4], 0
		inc ecx
	.ENDW
	
	mov	byte ptr [buffer],0
	
	mov ofn.lStructSize, SIZEOF OPENFILENAME
    mov	eax, hWndParent
    mov	ecx, hInstance
    mov	ofn.hWndOwner, eax
    mov ofn.hInstance, ecx
	mov ofn.lpstrFilter, offset filterBrain
    lea	ecx, buffer
    mov ofn.nMaxFile, MAX_PATH
    mov ofn.lpstrFile, ecx
    mov ofn.lpstrTitle, offset brainTitleSave
    mov ofn.Flags, OFN_PATHMUSTEXIST or OFN_OVERWRITEPROMPT
   	invoke GetSaveFileName, addr ofn  
    .IF		eax
    	invoke	CreateFile, addr buffer, GENERIC_WRITE,\
    				FILE_SHARE_READ, NULL, CREATE_ALWAYS,\
    				NULL, NULL
    	mov ebx, eax
    	.IF		eax==INVALID_HANDLE_VALUE
    		invoke	MessageBox, hWndParent, addr errSaveFile, addr AppName, MB_ICONERROR
    	.ELSE
    		method lpCharNet, NNet, save, NNETFLAG_TOFILE, ebx
    		.IF	   !eax
	    		invoke	MessageBox, hWndParent, addr errSaveFile, addr AppName, MB_ICONERROR
	    	.ENDIF
	    	invoke	CloseHandle, ebx
	    .ENDIF
    .ENDIF
ret
SaveBrainToFile		endp