;===============================================================================
; Neural networks: Digital brain
; Version 2
; (C) 2002 by Thomas Bleeker [exagone]. http://www.MadWizard.org
;===============================================================================
.586
.MMX

.model 	flat,stdcall
option	casemap:none

;-----------------------------------------------------------------------------
; Libraries & Include files
;-----------------------------------------------------------------------------

includelib 	<kernel32.lib>
includelib 	<user32.lib>
includelib 	<gdi32.lib>
includelib 	<comctl32.lib>
includelib 	<masm32.lib>
includelib 	<comdlg32.lib>

include 	<windows.inc>
include 	<kernel32.inc>
include 	<comctl32.inc>
include 	<masm32.inc>
include 	<user32.inc>
include 	<gdi32.inc>
include		<comdlg32.inc>

include		includes\objects.inc
include		general.inc
include		includes\NNet.asm
include		data.asm
include		datafuncs.asm
include		resource.inc

include		includes\pnglib.inc
includelib  includes\pnglib_custom.lib

;-----------------------------------------------------------------------------
; Prototypes
;-----------------------------------------------------------------------------
WinMain 				PROTO 	STDCALL :DWORD, :DWORD, :DWORD, :DWORD
WndProc 				PROTO 	STDCALL :DWORD, :DWORD, :DWORD, :DWORD
InitializeRes			PROTO 	STDCALL :DWORD
BitmapFromPNGRes		PROTO 	STDCALL :DWORD, :DWORD, :DWORD
Paint_Proc				PROTO	STDCALL :DWORD
StartDrawing			PROTO	STDCALL :DWORD, :DWORD, :DWORD
StopDrawing				PROTO	STDCALL :DWORD, :DWORD, :DWORD
ContinueDrawing			PROTO	STDCALL :DWORD, :DWORD, :DWORD
DoLine					PROTO	STDCALL :DWORD, :DWORD, :DWORD
RecognizeCharacter		PROTO 	STDCALL :DWORD
DrawGraphs				PROTO 	STDCALL
CalculateSinCos			PROTO 	STDCALL
DrawGraphAverages		PROTO 	STDCALL
UpdateTrainListBox		PROTO	STDCALL
TrainDrawingStopped		PROTO	STDCALL
RestoreTrainedDrawing	PROTO	STDCALL
DoTrain					PROTO	STDCALL :DWORD
ShowResults				PROTO	STDCALL
BrainWash				PROTO	STDCALL :DWORD

;-----------------------------------------------------------------------------
; Included code
;-----------------------------------------------------------------------------
include extraprocs.asm
include PanelDlgProc.asm

;-----------------------------------------------------------------------------
; Uninitialized data
;-----------------------------------------------------------------------------
.data?

hInstance			  dd ?

;-----------------------------------------------------------------------------
; Code
;-----------------------------------------------------------------------------

.code
start:
	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	invoke	InitCommonControls
	
	invoke  WinMain, hInstance, NULL, NULL, SW_SHOWNORMAL
	
    invoke	ExitProcess, NULL
    
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL hwnd:DWORD
    LOCAL msg:MSG
    LOCAL dwWidth:DWORD
    LOCAL dwHeight:DWORD
    LOCAL dwX:DWORD
    LOCAL dwY:DWORD
    
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style,   CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInst
    pop     wc.hInstance
    invoke	GetStockObject, WHITE_BRUSH
    mov     wc.hbrBackground, eax
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadImage,hInst,IDI_ICON1, IMAGE_ICON, 32, 32, 0
    mov     wc.hIcon,   eax
    invoke  LoadImage,hInst,IDI_ICON1, IMAGE_ICON, 16, 16, 0
    mov     wc.hIconSm, eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,    addr wc
    
 	invoke	GetSystemMetrics, SM_CXFRAME
 	shl		eax, 1
 	add		eax, WINDOW_WIDTH
 	mov		dwWidth, eax
 	invoke	GetSystemMetrics, SM_CYFRAME
 	shl		eax, 1
 	add		eax, WINDOW_HEIGHT
 	mov		dwHeight, eax
 	invoke	GetSystemMetrics, SM_CYCAPTION	
 	add		dwHeight, eax
 	
 	invoke	GetSystemMetrics, SM_CXSCREEN
 	sub		eax, dwWidth
 	shr		eax, 1
 	mov		dwX, eax
 
 	invoke	GetSystemMetrics, SM_CYSCREEN
 	sub		eax, dwHeight
 	shr		eax, 1
 	mov		dwY, eax
 	
    INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           (WS_OVERLAPPEDWINDOW OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN) \
           AND NOT (WS_MAXIMIZEBOX OR WS_MINIMIZEBOX OR WS_SIZEBOX),\
            dwX,dwY,dwWidth,dwHeight,NULL,NULL,\
           hInst,NULL
    mov   hwnd,eax
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd
    .WHILE TRUE
        invoke GetMessage, ADDR msg,NULL,0,0
  		
        .BREAK .IF (!eax)
         invoke TranslateMessage, ADDR msg
         invoke DispatchMessage, ADDR msg
           
    .ENDW
    mov     eax,msg.wParam
    ret
WinMain endp

UpdateTrainListBox	proc
LOCAL buffer[MAX_PATH]:BYTE
	invoke	GetAppPath, addr buffer
	invoke	lstrcat, addr buffer, addr trainDirF
	invoke	DlgDirList, hTrainDlg, addr buffer, IDC_TRAINFILES, NULL, \
				DDL_ARCHIVE OR DDL_READWRITE
ret
UpdateTrainListBox	endp

WndProc proc uses ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL tmpRct:RECT
LOCAL hStdFont:DWORD
LOCAL rsBuffer[2]:BYTE
	mov eax, uMsg
	.IF eax==WM_CREATE

		invoke	CreateDialogParam, hInstance, IDD_PANEL, hWnd, addr PanelDlgProc, 0
		mov		hTrainDlg, eax
		invoke	MoveWindow, eax,MAIN_CHILD_DLG_X, MAIN_CHILD_DLG_Y,\
					 MAIN_CHILD_DLG_W,MAIN_CHILD_DLG_H,1

		invoke	CreateDialogParam, hInstance, IDD_PANEL2, hWnd, addr PanelDlgProc, 0
		mov		hRunDlg, eax
				invoke	MoveWindow, eax,MAIN_CHILD_DLG_X, MAIN_CHILD_DLG_Y,\
					 MAIN_CHILD_DLG_W,MAIN_CHILD_DLG_H,1
		
		invoke	ShowWindow, hTrainDlg, SW_HIDE
		
		invoke	GetStockObject, DEFAULT_GUI_FONT
		mov		hStdFont,eax
		invoke		CreateWindowEx, NULL, addr classButton, \
						addr textTrain, WS_CHILD OR WS_VISIBLE OR BS_AUTORADIOBUTTON \
						, \
						RADIO_TRAIN_X, RADIO_TRAIN_Y, 100, 25, hWnd, IDC_RADIO_TRAIN, hInstance, NULL
		invoke	SendMessage, eax, WM_SETFONT, hStdFont, 0
		
	
		invoke		CreateWindowEx, NULL, addr classButton, \
						addr textRun, WS_CHILD OR WS_VISIBLE OR BS_AUTORADIOBUTTON \
						, \
						RADIO_RUN_X, RADIO_RUN_Y, 100, 25, hWnd, IDC_RADIO_RUN, hInstance, NULL
		invoke	SendMessage, eax, WM_SETFONT, hStdFont, 0
		invoke	CheckDlgButton, hWnd, IDC_RADIO_RUN, BST_CHECKED

		invoke	UpdateTrainListBox
		
		newobject	NNet, offset CharNetInfo
		mov			lpCharNet, eax
		invoke		FindResource, hInstance, IDR_NETDATA, RT_RCDATA
		invoke		LoadResource, hInstance, eax
		method		lpCharNet, NNet, initRandom

		invoke		lstrcpy, addr resultText, addr introText
		inc			bResTxtChanged
		invoke		InitializeRes, hWnd
		invoke		Resample, pBigBitmap, pSmallBitmap,\
						 RESAMPLE_SMALL_WIDTH*2, RESAMPLE_SMALL_HEIGHT*2
		invoke		AllocCurTDAT
		
		invoke		InvalidateRect, hWnd, NULL, FALSE
		
	.ELSEIF eax==WM_COMMAND
		mov		eax, wParam
		shr		eax, 16
		mov		ecx, wParam
		and		ecx, 0FFFFh
		.IF		eax==BN_CLICKED
			.IF		ecx==IDC_RADIO_TRAIN
				invoke	ShowWindow, hRunDlg, SW_HIDE
				invoke	ShowWindow, hTrainDlg, SW_SHOW
				mov		dwCurMode, CURMODE_TRAIN
				
				push	curPoint
				invoke	RestoreTrainedDrawing
				pop		curPoint
				
				invoke	Resample, pBigBitmap, pSmallBitmap,\
					 RESAMPLE_SMALL_WIDTH*2, RESAMPLE_SMALL_HEIGHT*2
				invoke	Resample, pBGraphBmp, pSGraphBmp, \
						GRAPH_SMALL_WIDTH*2, GRAPH_SMALL_HEIGHT*2
			
				invoke	InvalidateRect, hWnd, NULL, FALSE		
			.ELSEIF cx==IDC_RADIO_RUN
				mov		dwCurMode, CURMODE_RUN
				mov		dwResult, 0
				invoke	ShowWindow, hRunDlg, SW_SHOW
				invoke	ShowWindow, hTrainDlg, SW_HIDE
				invoke	InvalidateRect, hWnd, NULL, FALSE
			.ENDIF
		.ENDIF
	.ELSEIF eax==WM_CTLCOLORSTATIC 
		invoke	GetStockObject, WHITE_BRUSH
	.ELSEIF eax==WM_LBUTTONDOWN
		invoke	SetFocus, hWnd
		
		mov		eax, lParam
		mov		ecx, eax
		shr		ecx, 16
		and		eax, 0ffffh
		sub		eax, TABLET_MARGIN_LEFT
		js		@a_not
		sub		ecx, TABLET_MARGIN_TOP
		js		@a_not
		.IF		(SDWORD ptr eax<TABLET_WIDTH) && (SDWORD ptr ecx<TABLET_HEIGHT)
			invoke	StartDrawing, hWnd, eax, ecx
			jmp		@nnnn
		.ENDIF
		@a_not:
		.IF		dwCurMode==CURMODE_TRAIN
			mov		eax, lParam
			mov		ecx, eax
			shr		ecx, 16
			and		eax, 0ffffh
			sub		eax, ALPHABET_X
			js		@a_noc
			sub		ecx, ALPHABET_Y
			js		@a_noc
			.IF		(SDWORD ptr eax<ALPHABET_W) && (SDWORD ptr ecx<ALPHABET_H)
				.IF		ecx>=ALPHABET_ONECHAR_H
					mov		ebx, 13	;second row
				.ELSE
					xor		ebx, ebx
				.ENDIF
				xor		edx, edx
				mov		ecx, ALPHABET_ONECHAR_W
				div		ecx
				add		eax, ebx
				inc		eax
				mov		dwSelectedChar, eax
				push	curPoint
				invoke	RestoreTrainedDrawing
				pop		curPoint
				
				invoke	Resample, pBigBitmap, pSmallBitmap,\
					 RESAMPLE_SMALL_WIDTH*2, RESAMPLE_SMALL_HEIGHT*2
				invoke	Resample, pBGraphBmp, pSGraphBmp, \
						GRAPH_SMALL_WIDTH*2, GRAPH_SMALL_HEIGHT*2
				invoke	InvalidateRect, hWnd, 0,0
		
			.ENDIF
			@a_noc:
		.ELSE
			mov		eax, lParam
			mov		ecx, eax
			shr		ecx, 16
			and		eax, 0ffffh
			sub		eax, TABLET_MARGIN_LEFT
			
			.IF		ecx<TABLET_MARGIN_TOP && (eax < TABLET_WIDTH)
				push	ebx
				push	eax
									
				
				invoke	GetDlgItem, hRunDlg, IDC_RESULT
				mov		ebx, eax
				invoke	GetWindowTextLength, ebx
				mov		ecx, eax	;ecx = text length
				
				pop		eax
				.IF		eax < (TABLET_WIDTH/2)
					; backspace
					mov 	byte ptr [rsBuffer], 0
					or		ecx, ecx
					mov		edx, ecx
					jz		@F
					dec		edx
					@@:
					invoke	SendMessage, ebx, EM_SETSEL, edx, ecx
				.ELSE
					; add space
					mov 	word ptr [rsBuffer], 0020h
					invoke	SendMessage, ebx, EM_SETSEL, ecx, ecx
				.ENDIF
				invoke	SendMessage, ebx, EM_REPLACESEL, FALSE, addr rsBuffer
				pop		ebx

			.ENDIF
		.ENDIF	
		
		@nnnn:
		
	.ELSEIF eax==WM_MOUSEMOVE
		.IF		bDrawing
			mov		eax, lParam
			mov		ecx, eax
			shr		ecx, 16
			and		eax, 0ffffh
			sub		eax, TABLET_X
			js		@F
			sub		ecx, TABLET_Y
			js		@F
			.IF		(SDWORD ptr eax<TABLET_W) && (SDWORD ptr ecx<TABLET_H)
				invoke	ContinueDrawing, hWnd, eax, ecx
				;.IF		curPoint
			.ENDIF	
			@@:
		.ENDIF	
	.ELSEIF eax==WM_LBUTTONUP
		mov		eax, lParam
		mov		ecx, eax
		shr		ecx, 16
		and		eax, 0ffffh
		sub		eax, TABLET_X
		sub		ecx, TABLET_Y
		.IF		bDrawing
			invoke	StopDrawing, hWnd, eax, ecx
		.ENDIF	
	.ELSEIF eax==WM_PAINT
        invoke 	Paint_Proc,hWnd
		xor		eax, eax
	.ELSEIF eax==WM_DESTROY
	
		invoke	DestroyCurTDAT
		
		
		push -1
		push hBackBmp
		push hCaptionBmp
		push hResultBmp
		push hBigBitmap
		push hSmallBitmap
		push hBigPen
		push hBlueBrush
		push hCourierFont
		push hGraphsBackBmp
		push hSGraphBmp
		push hBGraphBmp
		push hGraphPen
		push hGraphBrush
		push hGreyPen
		
		@@:
		cmp		dword ptr [esp], -1
		je		@F
		call	DeleteObject
		jmp		@B
		@@:
		pop		eax
		
		push -1
		push hBackDC
		push hCaptionDC
		push hResultDC
		push hBigDC
		push hSmallDC
		push hGraphsBackDC
		push hSGraphDC
		push hBGraphDC
		
		@@:
		cmp		dword ptr [esp], -1
		je		@F
		call	DeleteDC
		jmp		@B
		@@:
		pop		eax
		
		destroy lpCharNet
		; Post quit message:
		invoke 	PostQuitMessage, NULL
	.ELSE
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	.ENDIF
ret 
WndProc endp


.code
InitializeRes proc hWnd:DWORD
LOCAL hDC:DWORD
	invoke	GetDC, hWnd
	mov		hDC, eax
	invoke	CreateCompatibleDC, NULL
	mov		hBackDC, eax
	invoke	CreateCompatibleBitmap, hDC, WINDOW_WIDTH, WINDOW_HEIGHT
	mov		hBackBmp, eax
	invoke	SelectObject, hBackDC, hBackBmp
	
	invoke	BitmapFromPNGRes, hWnd, hInstance, IDR_DRAWTABLET
	mov		hCaptionBmp, eax
	invoke	CreateCompatibleDC, NULL
	mov		hCaptionDC, eax
	invoke	SelectObject, eax, hCaptionBmp
	
	invoke	BitmapFromPNGRes, hWnd, hInstance, IDR_OUTPUT
	mov		hResultBmp, eax
	invoke	CreateCompatibleDC, NULL
	mov		hResultDC, eax
	invoke	SelectObject, eax, hResultBmp
	
	invoke	BitmapFromPNGRes, hWnd, hInstance, IDR_GRAPHS
	mov		hGraphsBackBmp, eax
	invoke	CreateCompatibleDC, NULL
	mov		hGraphsBackDC, eax
	invoke	SelectObject, eax, hGraphsBackBmp
	
	; --------------------------
	; drawing tablet  
	;
	invoke	CreateCompatibleDC, NULL
	mov		hBigDC, eax
	invoke	CreateDIBSection, eax, addr bigBI, DIB_RGB_COLORS, addr pBigBitmap, \
				0, 0
	mov		hBigBitmap, eax
	invoke	SelectObject, hBigDC, hBigBitmap
	
	invoke	CreateCompatibleDC, NULL
	mov		hSmallDC, eax
	invoke	CreateDIBSection, eax, addr SmallBI, DIB_RGB_COLORS, addr pSmallBitmap, \
				0, 0
	mov		hSmallBitmap, eax
	invoke	SelectObject, hSmallDC, hSmallBitmap

	invoke	CreatePen, PS_SOLID, 3, 8D2547h
	mov		hBigPen, eax
	invoke	SelectObject, hBigDC, eax
	
	invoke	GetStockObject, WHITE_BRUSH
	invoke	FillRect, hBigDC, addr valuesRect, eax
	
	invoke	CreateSolidBrush, 0EADEC8h
	mov		hBlueBrush, eax
	
	invoke	FillRect, hBigDC, addr backRect, eax
	
	invoke	CreateFont, -35, 0, 0, 0, FW_NORMAL,\
				FALSE, FALSE, FALSE, NULL, 0, 0, 0, FIXED_PITCH, addr fontCourier
	mov		hCourierFont, eax
	invoke	SelectObject, hBigDC, eax
	
	
	;--------------- graph data bitmaps ----------
		; --------------------------
	; drawing tablet  
	;
	invoke	CreateCompatibleDC, NULL
	mov		hBGraphDC, eax
	invoke	CreateDIBSection, eax, addr BGraphBI, DIB_RGB_COLORS, addr pBGraphBmp, \
				0, 0
	mov		hBGraphBmp, eax
	invoke	SelectObject, hBGraphDC, hBGraphBmp
	
	invoke	CreateCompatibleDC, NULL
	mov		hSGraphDC, eax
	invoke	CreateDIBSection, eax, addr SGraphBI, DIB_RGB_COLORS, addr pSGraphBmp, \
				0, 0
	mov		hSGraphBmp, eax
	invoke	SelectObject, hSGraphDC, hSGraphBmp

	invoke	CreatePen, PS_SOLID, 2, 303030h
	mov		hGraphPen, eax
	invoke	SelectObject, hBGraphDC, eax
	
	invoke	CreateSolidBrush, 0F3E5F0h
	mov		hGraphBrush, eax
	
	invoke	FillRect, hBGraphDC, addr graphsRect, eax

	invoke	CreatePen, PS_SOLID, 1, 09F9F9Fh
	mov		hGreyPen, eax
	invoke	SelectObject, hSGraphDC, eax
	
	;---------------end---------------------

	invoke	ReleaseDC, hWnd, hDC
	

ret
InitializeRes endp


; Converts a PNG file in resources to a bitmap handle.
; Cleanup this handle when not used anymore.
; Returns 0 on failure, otherwise the return value is the 
; new bitmap's handle
BitmapFromPNGRes	proc uses ebx hWndCompatible:DWORD, hInst:DWORD, dwResID:DWORD
LOCAL	pngInfo:PNGINFO
	invoke	PNG_Init, addr pngInfo
	invoke	PNG_LoadResource, addr pngInfo, hInst, dwResID
	invoke	PNG_Decode, addr pngInfo
	invoke	PNG_CreateBitmap, addr pngInfo, hWndCompatible, PNG_OUTF_AUTO, FALSE
	push	eax
	invoke	PNG_Cleanup, addr pngInfo
	pop		eax
ret
BitmapFromPNGRes	endp



Paint_Proc proc uses ebx esi edi hWnd:DWORD

    LOCAL hDC      :DWORD

    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT
	LOCAL tempBuffer[MAX_POS_SAMPLES]:BYTE
	LOCAL tempRest:DWORD
	LOCAL temp1:DWORD
	
    invoke BeginPaint,hWnd,ADDR Ps
    mov hDC, eax


  ; ----------------------------------------
	invoke	GetStockObject, WHITE_BRUSH
	invoke	FillRect, hBackDC, addr backRect, eax
	
	.IF bResTxtChanged
		invoke	GetStockObject, WHITE_BRUSH
		invoke	FillRect, hBigDC, addr valuesRect, eax
		invoke	DrawText, hBigDC, addr resultText, -1, \
				addr valuesRect, DT_CENTER OR DT_VCENTER
		and 	bResTxtChanged, 0
		jmp		@resample
	.ENDIF

	invoke	DrawGraphs
	
	.IF		bDrawing
		@resample:
		invoke	Resample, pBigBitmap, pSmallBitmap,\
					 RESAMPLE_SMALL_WIDTH*2, RESAMPLE_SMALL_HEIGHT*2
		invoke	Resample, pBGraphBmp, pSGraphBmp, GRAPH_SMALL_WIDTH*2, GRAPH_SMALL_HEIGHT*2
	.ENDIF
	
	invoke	BitBlt, hBackDC, TABLET_X, TABLET_Y,\
				 RESAMPLE_SMALL_WIDTH, RESAMPLE_SMALL_HEIGHT, hSmallDC, 0, 0, SRCCOPY
	invoke	BitBlt, hBackDC, CAPTION_X, CAPTION_Y, CAPTION_W, CAPTION_H, hCaptionDC, 0,0, SRCCOPY
	invoke	BitBlt, hBackDC, GRAPH_LEGENDA_X, GRAPH_LEGENDA_Y,\
					GRAPH_LEGENDA_W, GRAPH_LEGENDA_H, hGraphsBackDC, 0,0, SRCCOPY
	
	; Draw seperator between sin and cos
	invoke	MoveToEx, hSGraphDC, 0, GRAPH_SMALL_HEIGHT*3/4, 0
	invoke	LineTo, hSGraphDC, GRAPH_SMALL_WIDTH,GRAPH_SMALL_HEIGHT*3/4
	
	

	invoke	BitBlt, hBackDC, GRAPH_LEGENDA_X+GRAPH1_X_RELATIVE,\
							 GRAPH_LEGENDA_Y+GRAPH1_Y_RELATIVE,\
							 GRAPH_SMALL_WIDTH, ONEGRAPH_HEIGHT, hSGraphDC, 0,0, SRCCOPY
							  
	invoke	BitBlt, hBackDC, GRAPH_LEGENDA_X+GRAPH2_X_RELATIVE,\
							 GRAPH_LEGENDA_Y+GRAPH2_Y_RELATIVE,\
							 GRAPH_SMALL_WIDTH, ONEGRAPH_HEIGHT, hSGraphDC, 0,ONEGRAPH_HEIGHT,SRCCOPY
	

	
	invoke	BitBlt, hBackDC, ALPHABET_X, ALPHABET_Y, ALPHABET_W, ALPHABET_H, hResultDC,\
							 0,ALPHABET_NORMAL_VOFFSET, SRCCOPY
	
	.IF		dwCurMode==CURMODE_TRAIN
		xor		esi, esi
		mov		ebx, pCurTDAT
		@ml:
		mov		eax, (TDAT ptr [ebx]).nCoords
		or		eax, eax
		jz		@njjj
		mov		eax, esi		
		.IF		eax>12			;second row (>'M') ?
			sub		eax, 13		;substract 'M' to get index in second row
		.ENDIF
		mov		ecx, ALPHABET_ONECHAR_W			
		mul		ecx
		mov		edx, eax
		add		edx, ALPHABET_X
		mov		edi, ALPHABET_SET_VOFFSET
		mov		ecx, ALPHABET_Y
		.IF		esi>12		; >'M'? second row
			add		edi, ALPHABET_ONEROW_H
			add		ecx, ALPHABET_ONEROW_H
		.ENDIF
		invoke	BitBlt, hBackDC, edx, ecx, ALPHABET_ONECHAR_W, ALPHABET_ONECHAR_H, hResultDC, eax, edi, SRCCOPY	
		
		@njjj:
		inc		esi
		add		ebx, SIZEOF TDAT
		cmp		esi, 26
		jb		@ml
	
	.ENDIF
	
	
	
	.IF		dwCurMode==CURMODE_RUN
		mov		esi, dwResult
	.ELSE
		mov		esi, dwSelectedChar
	.ENDIF
	
	mov		eax, esi
	.IF		eax
		dec		eax				;-1 (!!!)
		.IF		eax>12			;second row (>'M') ?
			sub		eax, 13		;substract 'M' to get index in second row
		.ENDIF
		mov		ecx, ALPHABET_ONECHAR_W			
		mul		ecx
		mov		edx, eax
		add		edx, ALPHABET_X
		mov		ebx, ALPHABET_SELECTED_VOFFSET
		mov		ecx, ALPHABET_Y
		.IF		esi>13		; >'M'? second row
			add		ebx, ALPHABET_ONEROW_H
			add		ecx, ALPHABET_ONEROW_H
		.ENDIF
		invoke	BitBlt, hBackDC, edx, ecx, ALPHABET_ONECHAR_W, ALPHABET_ONECHAR_H, hResultDC, eax, ebx, SRCCOPY	
	.ENDIF	
	
	
	invoke	BitBlt, hDC, 0,0, WINDOW_WIDTH,WINDOW_HEIGHT, hBackDC, 0,0,SRCCOPY
  ; ----------------------------------------

	
    invoke EndPaint,hWnd,ADDR Ps

    ret

Paint_Proc endp

StartDrawing	proc	hWnd:DWORD, posX:DWORD, posY:DWORD
	.IF		dwCurMode == CURMODE_TRAIN && hCurTDATFile==NULL
		invoke MessageBox, NULL, addr errNewFileFirst, addr AppName, MB_ICONERROR
	.ELSE	
		inc		bDrawing
		and		dwResult, 0

		invoke	FillRect, hBigDC, addr backRect, hBlueBrush
		invoke	DoLine, hWnd, posX, posY
		invoke	InvalidateRect, hWnd, NULL, FALSE			
		invoke	SetCapture, hWnd
	.ENDIF
ret
StartDrawing	endp

ContinueDrawing	proc	hWnd:DWORD, posX:DWORD, posY:DWORD
	invoke	DoLine, hWnd, posX, posY
	invoke	InvalidateRect, hWnd, NULL, FALSE			
	
ret
ContinueDrawing	endp

StopDrawing proc	uses ebx hWnd:DWORD, posX:DWORD, posY:DWORD
LOCAL buffer[2]:BYTE
	invoke	ReleaseCapture
	invoke	CalculateSinCos
	.IF		!eax
		invoke	MessageBeep, 0
	.ELSE
		invoke	DrawGraphAverages
		.IF		dwCurMode==CURMODE_TRAIN
			invoke	TrainDrawingStopped
		.ELSEIF dwCurMode==CURMODE_RUN
			invoke	RecognizeCharacter, hWnd
			invoke	ShowResults
		.ENDIF
		
	.ENDIF
	
	inc		bResTxtChanged
	invoke	InvalidateRect, hWnd, NULL, FALSE			
	and		bDrawing, 0
	
	and		curPoint, 0
	and		curPosIdx, 0
	or		oldX, -1
	or		oldY, -1
	or		oldMeasureX, -1
	or		oldMeasureY, -1
ret
StopDrawing	endp


RestoreTrainedDrawing proc uses ebx esi edi

	invoke	FillRect, hBigDC, addr backRect, hBlueBrush	
	invoke	FillRect, hBGraphDC, addr graphsRect, hGraphBrush
	mov		eax, dwSelectedChar
	dec		eax
	mov		ecx, SIZEOF TDAT
	mul		ecx
	mov		ebx, eax
	add		ebx, pCurTDAT
	
	
	mov		esi, (TDAT ptr [ebx]).nCoords

	or		esi, esi
	jz		@end
	

	push	ebx
	lea		ebx, (TDAT ptr [ebx]).coords
	
		
	dec		esi
	mov		eax, (POINT ptr [ebx]).x
	mov		ecx, (POINT ptr [ebx]).y
	shl		eax, 1
	shl		ecx, 1
	invoke	MoveToEx, hBigDC, eax, ecx, 0
	add		ebx, SIZEOF POINT

	@@:
		mov		eax, (POINT ptr [ebx]).x
		mov		ecx, (POINT ptr [ebx]).y
		shl		eax, 1
		shl		ecx, 1
		invoke	LineTo, hBigDC, eax, ecx
		add		ebx, SIZEOF POINT
		dec		esi
	jnz		@B

	pop		ebx
	
	mov		eax, (TDAT ptr [ebx]).nAngles
	mov		curPoint, eax
	shl		eax, 2
	invoke	MemCopy, addr (TDAT ptr [ebx]).angles, addr angleArray, eax
	invoke	DrawGraphs
	invoke	CalculateSinCos
	invoke	DrawGraphAverages
@end:
ret
RestoreTrainedDrawing endp

TrainDrawingStopped	proc uses ebx esi edi
LOCAL	BytesWritten:DWORD
	mov		eax, dwSelectedChar
	dec		eax
	mov		ecx, SIZEOF TDAT
	
	mul		ecx
	mov		ebx, eax
	mov		edi, eax
	
	add		ebx, pCurTDAT
	invoke	MemCopy, addr inputArray, addr (TDAT ptr [ebx]).inputData, TRAIN_SAMPLES*2*4
	mov		eax, curPosIdx
	mov		(TDAT ptr [ebx]).nCoords, eax
	shl		eax, 3
	invoke	MemCopy, addr posArray, addr (TDAT ptr [ebx]).coords, eax
	mov		eax, curPoint

	mov		(TDAT ptr [ebx]).nAngles, eax
	shl		eax, 2
	
	invoke	MemCopy, addr angleArray, addr (TDAT ptr [ebx]).angles, eax
	
	mov		eax, hCurTDATFile
	.IF		eax
		invoke	SetFilePointer, eax, edi, NULL, FILE_BEGIN
		invoke 	WriteFile, hCurTDATFile, ebx, SIZEOF TDAT, addr BytesWritten, NULL
	.ENDIF
	ret
ret
TrainDrawingStopped endp

	
DoLine	proc	uses ebx hWnd:DWORD, posX:DWORD, posY:DWORD
LOCAL lineLength:DWORD
LOCAL tmp1:DWORD
LOCAL tmp2:DWORD
LOCAL dAngle:DWORD

	mov		eax, posX
	mov		ecx, posY
	.IF		oldX==-1 && oldY==-1
		mov		oldX, eax
		mov		oldMeasureX, eax
		mov		oldY, ecx
		mov		oldMeasureY, ecx
		mov		[posArray][0].x, eax
		mov		[posArray][0].y, ecx
	.ENDIF
	
	mov		eax, oldX
	mov		ecx, oldY
	shl		eax, 1
	shl		ecx, 1	
	invoke	MoveToEx, hBigDC, eax, ecx, 0
	
	mov		eax, posX
	mov		ecx, posY
	mov		oldX, eax
	mov		oldY, ecx
	shl		eax, 1
	shl		ecx, 1	
	invoke	LineTo, hBigDC, eax, ecx

	mov		eax, oldX
	mov		ecx, oldY
	
	sub		eax, oldMeasureX
	sub		ecx, oldMeasureY
	
	; calculate length of current point to previous point
	finit
	fild	oldX
	fild	oldMeasureX
	fsubp	st(1),st(0)
	fmul	st(0),st(0)
	
	fild	oldY
	fild	oldMeasureY
	fsubp	st(1),st(0)
	fmul	st(0),st(0)
	faddp	st(1),st(0)
	fsqrt
	fistp	lineLength
	
	; if 10 or bigger, calculate angle
	.IF		lineLength>10
		neg ecx
		invoke	DeltaToAngle, eax, ecx
		mov		dAngle, eax
		
		; calculate nr of 10length pieces:
		mov		eax, lineLength
		mov		ecx, 10
		xor		edx, edx
		div		ecx
		
		mov		ecx, curPoint
		add		ecx, eax
		.IF		ecx>=MAX_POS_SAMPLES
			invoke	MessageBeep, 0
			invoke	StopDrawing, hWnd, posX, posY
		.ELSE
			mov		ebx, curPoint
			mov		edx, dAngle
			mov		curPoint, ecx
			mov		eax, ecx
			
			; add angle for each 10 length piece:
			.WHILE	ebx<eax
				mov		[offset angleArray+ebx*4], edx
				inc		ebx
			.ENDW

		.ENDIF
	
;		mov		eax, posX
;		mov		ecx, posY
;		shl		eax, 1
;		shl		ecx, 1
;		mov		tmp1, eax
;		mov		tmp2, ecx
;		sub		eax, 5
;		sub		ecx, 5
;		add		tmp1, 5
;		add		tmp2, 5
;		invoke	Ellipse, hBigDC, eax, ecx, tmp1, tmp2 
		
  		mov		eax, oldX
  		mov		ecx, oldY
  		.IF dwCurMode==CURMODE_TRAIN
			mov		edx, curPosIdx
			lea		edx, [posArray][8*edx]
			mov		(POINT ptr [edx]).x, eax
			mov		(POINT ptr [edx]).y, ecx
			inc		curPosIdx
		.ENDIF
  		mov		oldMeasureX, eax
  		mov		oldMeasureY, ecx
	.ENDIF
ret
DoLine	endp

RecognizeCharacter	proc uses ebx esi hWnd:DWORD
LOCAL tempval1:DWORD

	.IF		curPoint<TRAIN_SAMPLES
		jmp		@notenoughpoints
	.ENDIF

	method	lpCharNet, NNet, run, offset inputArray
	invoke	MemCopy, eax, addr recognizedOutput, SIZEOF recognizedOutput
	finit
	xor		ecx, ecx
	xor		edx, edx
	.WHILE	ecx<26
		fld		real4 ptr [eax+4*ecx]
		fmul	r10000
		fistp	tempval1
		
		.IF		tempval1>=edx
			mov		edx, tempval1
			mov		dwResult, ecx
			inc		dwResult
		.ENDIF
		inc		ecx
	.ENDW
	mov		eax, dwResult
	add		al, "A"-1
	
	xor		eax, eax
	inc		eax
	ret	
	
	@notenoughpoints:
	xor		eax, eax
ret
RecognizeCharacter	endp

DrawGraphs proc uses edi ebx esi
LOCAL temp1,temp2:DWORD

	.IF		[curPoint]>1
		invoke	FillRect, hBGraphDC, addr graphsRect, hGraphBrush
	
		; ---- draw angle graph ----
		xor		edi, edi
		xor		ebx, ebx
	
		.WHILE	ebx<[curPoint]
			
			mov		eax, GRAPH_SMALL_WIDTH*2
			mul		ebx
			mov		ecx, curPoint
			xor		edx, edx
			div		ecx
			mov		edi, eax
			
			mov		eax, [offset angleArray+4*ebx]
			mov		ecx, 3600/(ONEGRAPH_HEIGHT*2)
			
			xor		edx, edx
			div		ecx
			
			mov		ecx, ebx
			inc		ecx
			.IF		ecx==curPoint
				mov		edi, GRAPH_SMALL_WIDTH*2
			.ENDIF
			.IF		ebx==0
				invoke	MoveToEx, hBGraphDC, edi, eax, 0
			.ELSE
				invoke	LineTo, hBGraphDC, edi, eax
			.ENDIF
			
			add		edi, esi
			inc		ebx
		.ENDW
		
	
		; --- draw sin graph ----
		xor		edi, edi
		xor		ebx, ebx
	
		.WHILE	ebx<[curPoint]
			mov		eax, GRAPH_SMALL_WIDTH*2
			mul		ebx
			mov		ecx, curPoint
			xor		edx, edx
			div		ecx
			mov		edi, eax
			
			finit
			fild	dword ptr [offset angleArray+4*ebx]
			fdiv	r3600
			fldpi
			fadd	st(0),st(0)
			fmulp	st(1),st(0)
			fsin
			fmul	r50
			fistp	temp1
			neg		temp1
			add		temp1, ONEGRAPH_HEIGHT/2+ONEGRAPH_HEIGHT*2+1
			
			mov		ecx, ebx
			inc		ecx
			.IF		ecx==curPoint
				mov		edi, GRAPH_SMALL_WIDTH*2
			.ENDIF
			.IF		ebx==0
				invoke	MoveToEx, hBGraphDC, edi, temp1, 0
			.ELSE
				invoke	LineTo, hBGraphDC, edi, temp1
			.ENDIF
			
			add		edi, esi
			inc		ebx
		.ENDW
		
		; ---- draw cos graph ----
		xor		edi, edi
		xor		ebx, ebx
	
		.WHILE	ebx<[curPoint]
			mov		eax, GRAPH_SMALL_WIDTH*2
			mul		ebx
			mov		ecx, curPoint
			xor		edx, edx
			div		ecx
			mov		edi, eax
			
			finit
			fild	dword ptr [offset angleArray+4*ebx]
			fdiv	r3600
			fldpi
			fadd	st(0),st(0)
			fmulp	st(1),st(0)
			fcos
			fmul	r50
			fistp	temp1
			add		temp1, ONEGRAPH_HEIGHT/2+ONEGRAPH_HEIGHT*3+2
			.IF		temp1>(GRAPH_SMALL_HEIGHT*2-1)
				mov		temp1, GRAPH_SMALL_HEIGHT*2
			.ENDIF
			mov		ecx, ebx
			inc		ecx
			.IF		ecx==curPoint
				mov		edi, GRAPH_SMALL_WIDTH*2
			.ENDIF
			.IF		ebx==0
				invoke	MoveToEx, hBGraphDC, edi, temp1, 0
			.ELSE
				invoke	LineTo, hBGraphDC, edi, temp1
			.ENDIF
			
			add		edi, esi
			inc		ebx
		.ENDW
		
	.ENDIF
ret
DrawGraphs endp


CalculateSinCos	proc uses ebx esi edi
LOCAL	tempval1:DWORD
LOCAL	sinVals[MAX_POS_SAMPLES]:REAL4
LOCAL	cosVals[MAX_POS_SAMPLES]:REAL4

	.IF		curPoint<TRAIN_SAMPLES
		jmp		@notenoughpoints
	.ENDIF
	
	mov		eax, curPoint

	mov		ebx, offset angleArray
	lea		edx, sinVals
	lea		ecx, cosVals
	

	finit
	fldpi
	fadd	st(0),st(0)
	fdiv	r3600			;st(0)= 2pi/3600
	
	xor		eax, eax
	.WHILE	eax<curPoint
		fild	dword ptr [ebx+4*eax]
		;st(0)=angle (0-3599)
		;st(1)=2pi/3600
		fmul	st(0), st(1)
		fsincos
		;st(0)=cos of angle
		;st(1)=sin of angle
		;st(2)=2pi/3600
		fstp	real4 ptr [ecx+4*eax]		;store cosine of angle
		fstp	real4 ptr [edx+4*eax]		;store sine of angle
	inc eax
	.ENDW
	fstp	st(0)
	
	invoke	NonUniformAverages, offset inputArray, addr sinVals, TRAIN_SAMPLES, curPoint

	invoke	NonUniformAverages, offset inputArray + TRAIN_SAMPLES*4, addr cosVals, TRAIN_SAMPLES, curPoint
	
	xor		eax, eax 
	inc		eax
	ret
	@notenoughpoints:
	xor		eax, eax
ret
CalculateSinCos endp

DrawGraphAverages proc uses edi esi ebx
LOCAL	tempSin,tempCos:DWORD

	xor	edi, edi
		finit
	.WHILE	edi<TRAIN_SAMPLES


		fld		r50
		fld		real4 ptr [offset inputArray+4*edi]
		fmul	st(0),st(1)
		fistp	tempSin
		fld		real4 ptr [offset inputArray+4*edi+4*TRAIN_SAMPLES]
		fmul	st(0),st(1)
		fistp 	tempCos
		fstp	st(0)
		
		add		tempSin, ONEGRAPH_HEIGHT/2
	
		.IF		SDWORD ptr [tempSin]<0
			mov		tempSin, 0
		.ELSEIF		SDWORD ptr [tempSin]>ONEGRAPH_HEIGHT
			mov		tempSin, ONEGRAPH_HEIGHT
		.ENDIF

			
		mov		eax, GRAPH_AVG_WIDTH*2
		mul		edi
				
		mov		edx, tempSin

		neg		tempSin
		add		tempSin, ONEGRAPH_HEIGHT*2+ONEGRAPH_HEIGHT


		invoke	BlendFixed, pBGraphBmp, eax,tempSin, GRAPH_AVG_WIDTH*2, edx, 0C0B7F5h, GRAPH_SMALL_WIDTH*2

		add		tempCos, ONEGRAPH_HEIGHT/2
		.IF		SDWORD ptr [tempCos]<0
			mov		tempCos, 0
		.ELSEIF		SDWORD ptr [tempCos]>ONEGRAPH_HEIGHT
			mov		tempCos, ONEGRAPH_HEIGHT
		.ENDIF
		mov		eax, GRAPH_AVG_WIDTH*2
		mul		edi
		
		invoke	BlendFixed, pBGraphBmp, eax,ONEGRAPH_HEIGHT*2+ONEGRAPH_HEIGHT,\
							 GRAPH_AVG_WIDTH*2,tempCos, 0F5B7C1h, GRAPH_SMALL_WIDTH*2
		
		
		inc		edi
	.ENDW
ret
DrawGraphAverages endp

DoTrain proc uses esi edi ebx dwTrainCount:DWORD
	
	xor		edi, edi
	mov		eax, pCurTDAT
	.WHILE	edi<26
		@ml:
		mov		ecx, (TDAT ptr [eax]).nCoords
		or		ecx, ecx
		jz		@not_set
		add		eax, SIZEOF TDAT
		inc		edi
	.ENDW
	
	; all data set, train now
	
	; clear table
	mov		eax, offset outputArray
	.WHILE	eax<offset outputArray + 26*4
		mov		dword ptr [eax],0
		add		eax, 4
	.ENDW
	xor		ebx, ebx
	.WHILE	ebx<dwTrainCount
		mov		esi, pCurTDAT
		xor		edi, edi
		.WHILE	edi<26
			assume esi:PTR TDAT
			mov		[outputArray][4*edi], FLOAT_1_0
			method	lpCharNet, NNet, train, addr [esi].inputData, offset outputArray
			mov		[outputArray][4*edi], 0
			add		esi, sizeof TDAT
			inc		edi
			assume esi:nothing
		.ENDW
		inc		ebx
	.ENDW

ret

@not_set:
	invoke	MessageBox, NULL, addr errNotEnoughTrainData, addr AppName, MB_ICONERROR
	xor	eax, eax
ret
DoTrain endp

ShowResults proc uses ebx edi esi
LOCAL tempval:DWORD
LOCAL curMaxIndex:DWORD
LOCAL buffer[10]:BYTE

	
	mov 	eax, dwResult
	add		al, "A"-1
	mov		buffer[1], 0
	mov		buffer[0], al
	invoke	GetDlgItem, hRunDlg, IDC_RESULT
	mov		ebx, eax
	invoke	GetWindowTextLength, ebx
	
	invoke	SendMessage, ebx, EM_SETSEL, eax, eax
	invoke	SendMessage, ebx, EM_REPLACESEL, FALSE, addr buffer
	
	lea		edi, recognizedOutput
	
	invoke	GetDlgItem, hRunDlg, IDC_RESULTLIST
	mov		ebx, eax
	
	invoke	SendMessage, ebx, LB_RESETCONTENT, 0, 0
	
	xor		esi, esi

	mov		curMaxIndex, 0
	.WHILE	esi<10
		finit
		xor		edx, edx
		mov		ecx, 25
		.WHILE	SDWORD ptr ecx >= 0
			mov		eax, dword ptr [edi+4*ecx]
			cmp		eax, -1
			je		@F
				fld		real4 ptr [edi+4*ecx]
				fmul	r10000
				fistp	tempval
				
				.IF		tempval>=edx
					mov		edx, tempval
					mov		curMaxIndex, ecx
				.ENDIF
			@@:
			dec		ecx
		.ENDW
		mov	eax, curMaxIndex
		add	al, 'A'
		mov	buffer[0], al
		
		mov eax, edx
		mov ecx, 100
		xor	edx, edx
		div ecx
		invoke	wsprintf, addr buffer + 1, addr formatResultList, eax
		invoke 	SendMessage, ebx, LB_ADDSTRING, 0, addr buffer
		
		mov		eax, curMaxIndex
		mov		dword ptr [edi+4*eax], -1
		inc		esi
	.ENDW
	
	
	xor		eax, eax
	inc		eax
	ret	
ret
ShowResults endp

BrainWash proc hWnd:DWORD
	invoke	MessageBeep, 0
	method		lpCharNet, NNet, initRandom
ret
BrainWash endp

end start






